
type TCommandLineOption
  public:
    key as string
    value as string
end type

type TCommandLine
  public:
    declare constructor ()
    declare function HasOption(byref aOptionName as const string) as integer
    declare function GetOptionValue(byref aOptionName as const string) as string
    declare function GetAloneValueNth(byval n as integer) as string
  private:
    dim options(any) as TCommandLineOption
End Type

constructor TCommandLine ()
  erase(options)
  dim i as integer = 0
  do
    if command(i + 1) = "" then exit do
    redim preserve options(i)
    if left(command(i + 1), 2) = "--" then
      dim n as integer = instr(3, command(i + 1), "=")
      if n = 0 then
        options(i).key = mid(command(i + 1), 3)
      else
        options(i).key = mid(command(i + 1), 3, n - 3)
        options(i).value = mid(command(i + 1), n + 1)
      end if
    else
      options(i).value = command(i + 1)
    end if
    i += 1
  loop
end constructor

function TCommandLine.HasOption(byref aOptionName as const string) as integer
  for i as integer = LBound(options) to UBound(options)
    if (options(i).key <> "") andalso (options(i).key = aOptionName) then
      return -1
    end if
  next i
  return 0
end function

function TCommandLine.GetOptionValue(byref aOptionName as const string) as string
  for i as integer = LBound(options) to UBound(options)
    if (options(i).key <> "") andalso (options(i).key = aOptionName) then
      return options(i).value
    end if
  next i
  return ""
end function

function TCommandLine.GetAloneValueNth(byval n as integer) as string
  dim k as integer = 0
  for i as integer = LBound(options) to UBound(options)
    if options(i).key = "" then
      k += 1
      if k = n then
        return options(i).value
      end if
    end if  
  next i
  return ""
end function
