
#include "dir.bi"

function ChangeFileExt(byval aFileName as string, byval aExt as string) as string
  dim i as integer = InStrRev(aFileName, ".")
  if (i = 0) or (aExt = "") then
    return aFileName
  else
    if aExt[0] <> Asc(".") then
      aExt = "." & aExt
    end if
    return Left(aFileName, i - 1) & aExt
  end if
end function

function IncludeTrailingBackslash(byref aPath as const string) as string
  if Len(aPath) andalso (aPath[Len(aPath) - 1] <> Asc("\")) then
    return aPath & "\"
  end if
  return aPath
end function

sub GetExt(byval aPath as string, byval aExt as string, a() as string, byval aPreserve as integer = 0)
  dim i as integer
  dim s as string
  if aPreserve then
    i = UBound(a) - LBound(a) + 1
  else
    Erase(a)
    i = 0
  end if
  s = Dir(IncludeTrailingBackslash(aPath) & "*" & aExt, fbArchive)
  do while Len(s)
    redim preserve a(i)
    a(i) = s
    i += 1
    s = Dir()
  loop
end sub

function DirExists(byval aPath as string) as integer
  dim s as string, i as integer
  s = Dir(aPath, fbReadOnly or fbHidden or fbSystem or fbDirectory or fbArchive, i)
  if i and fbDirectory then
    return -1
  end if
  return 0
end function

function FindExt(byval aPath as string, byval aExt as string) as integer
  if len(aPath) then
    if aPath[len(aPath) - 1] <> asc("\") then
      aPath &= "\"
    end if
    if Len(aExt) andalso (aExt[0] <> Asc(".")) then
      aExt = "." & aExt
    end if
    return Dir(aPath & "*" & aExt) <> ""
  else
    return 0
  end if
end function

function ExtractFileExt(byval aPath as string) as string
  dim i as integer = InStrRev(aPath, ".")
  if i then
    return Mid(aPath, i)
  else
    return ""
  end if
end function
